Use #REF! error in INDEX()
[LibreOffice.git] / bin / check-elf-dynamic-objects
blob415dea8f46ee5170411b5ab1f90344a74297c04c
1 #!/usr/bin/env bash
3 # This file is part of the LibreOffice project.
5 # This Source Code Form is subject to the terms of the Mozilla Public
6 # License, v. 2.0. If a copy of the MPL was not distributed with this
7 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
10 # verify that ELF NEEDED entries are known-good so hopefully builds run on
11 # lots of different GNU/Linux distributions
13 set -euo pipefail
15 PARA=1
16 check_path="${INSTDIR:-.}"
18 help()
20 cat << "EOF"
21 -d <dir> directory to check
22 -p run unbound parallel checks
23 -h help
24 EOF
25 [ -z "${1:-}" ] && exit 0
28 die()
30 echo "$1"
31 echo
32 help 1
33 exit 1
36 while [ "${1:-}" != "" ]; do
37 parm=${1%%=*}
38 arg=${1#*=}
39 has_arg=
40 if [ "${1}" != "${parm?}" ] ; then
41 has_arg=1
42 else
43 arg=""
46 case "${parm}" in
47 --dir|-d)
48 if [ "$has_arg" ] ; then
49 check_path="$arg"
50 else
51 shift
52 check_path="$1"
54 if [ ! -d "$check_path" ]; then
55 die "Invalid directory '$check_path'"
58 -h)
59 help
61 -p)
62 # this sounds counter intuitive but the idea
63 # is to possibly support -p <n>
64 # in the meantime: 0 = nolimit and -p 1 would mean
65 # the current default: serialize
66 PARA=0
68 -*)
69 die "Invalid option $1"
72 if [ "$DO_NEW" = 1 ] ; then
73 REPO="$1"
74 else
75 die "Invalid argument $1"
78 esac
79 shift
80 done
83 files=$(find "${check_path}/program" "${check_path}/sdk/bin" -type f)
84 # all RPATHs should point to ${INSTDIR}/program so that's the files they find
85 programfiles=$(echo ${files} | grep -o '/program/[^/]* ' | xargs -n 1 basename)
87 # allowlists should contain only system libraries that have a good reputation
88 # of maintaining ABI stability
89 # allow extending the allowlist using the environment variable to be able to work
90 # on the installer stuff without the need for a baseline setup
91 globalallowlist="ld-linux-x86-64.so.2 ld-linux.so.2 libc.so.6 libm.so.6 libdl.so.2 libpthread.so.0 librt.so.1 libutil.so.1 libnsl.so.1 libcrypt.so.1 libgcc_s.so.1 libstdc++.so.6 libz.so.1 libfontconfig.so.1 libfreetype.so.6 libxml2.so.2 libxslt.so.1 libexslt.so.0 libnspr4.so libnss3.so libnssutil3.so libplc4.so libplds4.so libsmime3.so libssl3.so ${LO_ELFCHECK_ALLOWLIST-}"
92 x11allowlist="libX11.so.6 libX11-xcb.so.1 libXext.so.6 libSM.so.6 libICE.so.6 libXinerama.so.1 libXrender.so.1 libXrandr.so.2 libcairo.so.2"
93 openglallowlist="libGL.so.1"
94 gobjectallowlist="libgobject-2.0.so.0 libglib-2.0.so.0"
95 gdbusallowlist="libdbus-glib-1.so.2 libdbus-1.so.3 libgmodule-2.0.so.0 libgthread-2.0.so.0 ${gobjectallowlist}"
96 gioallowlist="libgio-2.0.so.0 ${gdbusallowlist}"
97 gstreamerallowlist="libgsttag-1.0.so.0 libgstaudio-1.0.so.0 libgstpbutils-1.0.so.0 libgstvideo-1.0.so.0 libgstbase-1.0.so.0 libgstreamer-1.0.so.0 ${gobjectallowlist}"
98 gtk3allowlist="libgtk-3.so.0 libgdk-3.so.0 libcairo-gobject.so.2 libpangocairo-1.0.so.0 libfribidi.so.0 libatk-1.0.so.0 libcairo.so.2 libpangoft2-1.0.so.0 libpango-1.0.so.0 libfontconfig.so.1 libfreetype.so.6 libgdk_pixbuf-2.0.so.0 libharfbuzz.so.0 ${gioallowlist}"
99 gtk4allowlist="libgtk-4.so.1 libcairo-gobject.so.2 libpangocairo-1.0.so.0 libatk-1.0.so.0 libcairo.so.2 libpango-1.0.so.0 libgdk_pixbuf-2.0.so.0 libharfbuzz.so.0 libgraphene-1.0.so.0 ${gioallowlist}"
100 qt5allowlist="libQt5Core.so.5 libQt5Gui.so.5 libQt5Network.so.5 libQt5Widgets.so.5 libQt5X11Extras.so.5 libcairo.so.2 libxcb.so.1 libxcb-icccm.so.4 ${gobjectallowlist}"
101 qt6allowlist="libQt6Core.so.6 libQt6Gui.so.6 libQt6Network.so.6 libQt6Widgets.so.6 libxcb.so.1"
102 kf5allowlist="libKF5ConfigCore.so.5 libKF5CoreAddons.so.5 libKF5I18n.so.5 libKF5KIOCore.so.5 libKF5KIOFileWidgets.so.5 libKF5KIOWidgets.so.5 libKF5WindowSystem.so.5"
103 avahiallowlist="libavahi-common.so.3 libavahi-client.so.3 ${gdbusallowlist}"
104 kerberosallowlist="libgssapi_krb5.so.2 libcom_err.so.2 libkrb5.so.3"
105 dconfallowlist="libdconf.so.1 libgio-2.0.so.0 ${gobjectallowlist}"
107 check_one_file()
109 local file="$1"
111 skip=0
112 allowlist="${globalallowlist}"
113 case "${file}" in
114 */sdk/docs/*)
115 # skip the majority of files, no ELF binaries here
116 skip=1
118 */_uuid.cpython-*.so)
119 allowlist="${allowlist} libuuid.so.1"
121 */libcairo-lo.so.2)
122 allowlist="${allowlist} ${x11allowlist} libxcb-shm.so.0 libxcb.so.1 libxcb-render.so.0"
124 */libcairocanvaslo.so)
125 allowlist="${allowlist} libcairo.so.2"
127 */libucpgio1lo.so|*/liblosessioninstalllo.so|*/libevoablo.so)
128 allowlist="${allowlist} ${gioallowlist}"
130 */libavmediagst.so)
131 allowlist="${allowlist} ${gstreamerallowlist}"
133 */libavmediagtk.so)
134 allowlist="${allowlist} ${gtk4allowlist}"
136 */libvclplug_kf5lo.so|*/libkf5be1lo.so)
137 if [ "$ENABLE_KF5" = TRUE ]; then
138 allowlist="${allowlist} ${qt5allowlist} ${kf5allowlist}"
141 */libvclplug_gtk3lo.so|*/updater)
142 allowlist="${allowlist} ${x11allowlist} ${gtk3allowlist}"
144 */libvclplug_gtk4lo.so)
145 allowlist="${allowlist} ${x11allowlist} ${gtk4allowlist}"
147 */libvclplug_qt5lo.so)
148 if [ "$ENABLE_QT5" = TRUE ]; then
149 allowlist="${allowlist} ${qt5allowlist}"
152 */libvclplug_qt6lo.so)
153 if [ "$ENABLE_QT6" = TRUE ]; then
154 allowlist="${allowlist} ${qt6allowlist}"
157 */libvclplug_gtk3_kde5lo.so)
158 if [ "$ENABLE_GTK3_KDE5" = TRUE ]; then
159 allowlist="${allowlist} ${x11allowlist} ${gtk3allowlist} ${qt5allowlist} ${kf5allowlist}"
162 */lo_kde5filepicker)
163 if [ "$ENABLE_GTK3_KDE5" = TRUE ]; then
164 allowlist="${allowlist} ${x11allowlist} ${gtk3allowlist} ${qt5allowlist} \
165 ${kf5allowlist}"
168 */libdesktop_detectorlo.so|*/oosplash|*/gengal.bin)
169 allowlist="${allowlist} ${x11allowlist}"
171 */libvclplug_genlo.so|*/libchartcorelo.so|*/libavmediaogl.so|*/libOGLTranslo.so|*/liboglcanvaslo.so)
172 allowlist="${allowlist} ${x11allowlist} ${openglallowlist}"
174 */libvcllo.so)
175 allowlist="${allowlist} ${x11allowlist} ${openglallowlist} ${gioallowlist} libcups.so.2"
177 */libsofficeapp.so)
178 allowlist="${allowlist} ${x11allowlist} ${openglallowlist} ${gioallowlist} libcups.so.2"
180 */liblibreofficekitgtk.so)
181 allowlist="${allowlist} ${gtk3allowlist}"
183 */libsdlo.so)
184 allowlist="${allowlist} ${avahiallowlist}"
186 */libskialo.so)
187 allowlist="${allowlist} ${openglallowlist} ${x11allowlist}"
189 */libofficebean.so)
190 allowlist="${allowlist} libjawt.so"
192 */libpostgresql-sdbc-impllo.so)
193 allowlist="${allowlist} ${kerberosallowlist}"
195 */libconfigmgrlo.so)
196 if [ "$ENABLE_DCONF" = TRUE ]; then
197 allowlist="${allowlist} ${dconfallowlist}"
200 */libmergedlo.so)
201 allowlist="${allowlist} ${x11allowlist} ${openglallowlist} ${gioallowlist} ${dconfallowlist} libcups.so.2 libcairo.so.2"
203 esac
204 if test "${skip}" = 0 && readelf -d "${file}" &> /dev/null ; then
205 rpath=$(readelf -d "${file}" | grep '(\(RPATH\|RUNPATH\))' || true)
206 neededs=$(readelf -d "${file}" | grep '(NEEDED)' | sed -e 's/.*\[\(.*\)\]$/\1/')
207 neededsinternal=
208 for needed in ${neededs}
210 if ! echo ${allowlist} | grep -q -w "${needed}" ; then
211 neededsinternal="${neededsinternal} ${needed}"
212 if ! echo ${programfiles} | grep -q -w "${needed}" ; then
213 echo "${file}" has suspicious NEEDED: "${needed}"
214 status=1
217 done
218 if test -z "${rpath}" ; then
219 case "${file}" in
220 */python-core-*/lib/lib-dynload/*)
221 # python modules don't have RPATH
223 */share/extensions/*)
224 # extension libraries don't have RPATH
227 # no NEEDED from instdir, no RPATH needed
228 if test -n "${neededsinternal}" ; then
229 echo "${file}" has no RPATH
230 status=1
233 esac
234 else
235 case "$file" in
236 */sdk/bin/*)
237 if echo "${rpath}" | grep -q -v '\[\$ORIGIN/../../program\]$' ; then
238 echo "${file}" has unexpected RPATH "${rpath}"
239 status=1
243 if echo "${rpath}" | grep -q -v '\[\$ORIGIN\]$' ; then
244 echo "${file}" has unexpected RPATH "${rpath}"
245 status=1
248 esac
252 status=0
254 if [ "$PARA" = "1" ] ; then
255 for file in ${files}
257 check_one_file $file
258 done
259 else
260 rm -f check_elf.out
261 for file in ${files}
264 check_one_file $file
265 )>> check_elf.out &
266 done
268 wait
270 if [ -s check_elf.out ] ; then
271 cat check_elf.out
272 status=1
274 rm check_elf.out
276 exit ${status}